require("framework.init")
require("framework.shortcodes")
require("framework.cc.init")
require("lfs")
local scheduler = require("framework.scheduler")

--[[
scheduler.scheduleGlobal(function()
    CCTextureCache:sharedTextureCache():dumpCachedTextureInfo()
    --CCTextureCache:sharedTextureCache():removeUnusedTextures()
  end,20)]]


-----------------------------预加载资源管理------------------------------------------------------
globalResources = {}
globalResources["CheckUpdateScene"]={}
globalResources["AnySdkLoginScene"]={}
globalResources["LoginScene"]={}
globalResources["MILoginScene"]={}
globalResources["NPCScene"]={}
globalResources["PVPBattleScene"]={}
globalResources["StartStoryScene"]={}
globalResources["BattleScene"]={}
-----------------------------预加载资源管理------------------------------------------------------
checkInUse = function(sceneName,plist,image)-------检测此资源在当前场景中是否还在使用
    if runningSceneName=="BattleScene" then
        if globalResources[runningSceneName][runningPassId]==nil then return false end
        for k, v in ipairs(globalResources[runningSceneName][runningPassId]) do
            if v[1]==plist and v[2]==image then
                return true
            end
        end
        return false
    else
        for k, v in ipairs(globalResources[runningSceneName]) do
            if v[1]==plist and v[2]==image then
                return true
            end
        end
        return false
    end
end

checkIfExist = function(sceneName,plist,image)-------检测此资源在当前场景中是否还在使用
    if sceneName=="BattleScene" then
        if globalResources[sceneName][runningPassId]==nil then return false end
        for k, v in ipairs(globalResources[sceneName][runningPassId]) do
            if v[1]==plist and v[2]==image then
                return true
            end
        end
        return false
    else
        for k, v in ipairs(globalResources[sceneName]) do
            if v[1]==plist and v[2]==image then
                return true
            end
        end
        return false
    end
end

addRes = function(sceneName,plist,image)
    if plist and image then
        if sceneName=="BattleScene" then
            if globalResources[sceneName][runningPassId]==nil then
                globalResources[sceneName][runningPassId] = {}
            end
            if not checkIfExist(sceneName,plist,image) then
                globalResources[sceneName][runningPassId][#globalResources[sceneName][runningPassId]+1] = {plist,image}
                display.addSpriteFramesWithFile(plist,image)
                --print(sceneName.."加载资源",plist,image)
            end
        else
            --if not checkIfExist(sceneName,plist,image) then
                --print("什么名字",sceneName)
                if globalResources[sceneName]==nil then
                    globalResources[sceneName] = {}
                end
                globalResources[sceneName][#globalResources[sceneName]+1] = {plist,image}
                display.addSpriteFramesWithFile(plist,image)
                --print(sceneName.."加载资源",plist,image)
            --end
        end
    else
        --print(sceneName.."未正确加载资源",plist,image)
    end
end
delRes = function(sceneName,passId)
    --print("当前在"..runningSceneName.."中释放"..sceneName.."场景中的资源")
    if sceneName=="BattleScene" then
        for k, v in ipairs(globalResources[sceneName][passId]) do
            local plist = v[1]
            local image = v[2]
            if checkInUse(sceneName,plist,image) then
                --print("此资源还在使用中,不能释放",plist,image)
            else
                --print("可以释放此资源",plist,image)
                display.removeSpriteFramesWithFile(plist,image)
            end
        end
        globalResources[sceneName][passId] = {}
    else
        for k, v in ipairs(globalResources[sceneName]) do
            local plist = v[1]
            local image = v[2]
            if checkInUse(sceneName,plist,image) then
                --print("此资源还在使用中,不能释放",plist,image)
            else
                --print("可以释放此资源",plist,image)
                display.removeSpriteFramesWithFile(plist,image)
            end
        end
        globalResources[sceneName] = {}
    end
end

local MyApp = class("MyApp", cc.mvc.AppBase)

function MyApp:ctor()
    MyApp.super.ctor(self)
    self.objects_ = {}
end

function MyApp:rmdir(path)
    local function _rmdir(path)
    local iter, dir_obj = lfs.dir(path)
    while true do
        local dir = iter(dir_obj)
        if dir == nil then break end
            if dir ~= "." and dir ~= ".." then
                local curDir = path..dir
                local mode = lfs.attributes(curDir, "mode") 
                if mode == "directory" then
                    _rmdir(curDir.."/")
                elseif mode == "file" then
                    os.remove(curDir)
                end
            end
        end
        local succ, des = os.remove(path)
        if des then print(des) end
        return succ
    end
    _rmdir(path)
    return true
end

function MyApp:run()
    print("RELEASE_PLATFORM=", RELEASE_PLATFORM)
    audio.setMusicVolume(0.5)
    audio.setSoundsVolume(1)

    --local tempPath = CCFileUtils:sharedFileUtils():getUpdateFilePath().."temp/"--每次进入程序时清空可能因为更新不成功解压不成功而产生的临时目录的垃圾文件
    --self:rmdir(tempPath)
    
    --CPlusMathUtil:setRandSeed()
    --真机发布
    --[[
    if io.exists(device.writablePath.."game/config.lua") then
        CCFileUtils:sharedFileUtils():addSearchPath(device.writablePath.."game/res/")
    end
    CCFileUtils:sharedFileUtils():addSearchPath("res/")]]
    --print("RELEASE_PLATFORM=", RELEASE_PLATFORM)

    --获得要采用的SDK
    local setStrFunc=function(funcStr, setStr, po)
         if (funcStr=="getSDK") then
            ACCOUNT_MODE = setStr
         else
            CHANNEL_ID = setStr
         end

    end
    local getSdkFunc = function(funcStr, defStr, callback)
        if  (device.platform == 'android') then
            local callbackI = function(str)
                setStrFunc(funcStr, str, 1)
              
                callback()
            end  --模拟器直接用时间
            local ok, ret = luaj.callStaticMethod("org/cocos2dx/lib/Function", funcStr, {callbackI},"(I)V")
            if not ok then
                setStrFunc(funcStr, defStr, 2)
                callback()
            end
        else
           
            setStrFunc(funcStr, defStr, 3)
            callback()
        end
    end

    local doFunc = function()
    require("config")
            local doFunc3 = function()
            if (RELEASE_PLATFORM == "test") then
            self:init()
            self:enterScene("TestScene")
            elseif (RELEASE_PLATFORM == "android") then
            self:init()
        --CCFileUtils:sharedFileUtils():addSearchPath(CCFileUtils:sharedFileUtils():getUpdateFilePath().."res/")
            CCFileUtils:sharedFileUtils():addSearchPath("res/")
            local function func_mobi() self:enterScene("LoginScene") end
            local function func_xiaomi() self:enterScene("MILoginScene") end
            CommUtil.accessPlatform(func_mobi, func_xiaomi)
        -- self:enterScene("AnySdkLoginScene")
        -- self:enterScene("LoginScene")
        
            elseif (RELEASE_PLATFORM == "auto_update") then
        --self:enterScene("UpdateScene")
            self:enterScene("CheckUpdateScene")
            else
            CCFileUtils:sharedFileUtils():addSearchPath("res/")
            self:init()
            self:enterScene("NPCScene")
            end
            end
            getSdkFunc("getDefChannelID", "000000", doFunc3)
    end
    --
    getSdkFunc("getSDK", "mobi", doFunc)
end

function MyApp:init()
    package.loaded["config"] = nil
    require("config")
    require("app.AppDef")
    CommUtil.InitAppData()
    --初始化测试用数据
    DebugUtil.initAppTestData()
    --网络轮循
    gSock.initSockScheduler() 
end

function MyApp:setObject(id, object)
    assert(self.objects_[id] == nil,string.format("MyApp:setObject() - id \"%s\" already exists",id))
    self.objects_[id] = object
end

function MyApp:getObject(id)
    assert(self.objects_[id] ~= nil, string.format("MyApp:getObject() - id \"%s\" not exists", id))
    return self.objects_[id]
end

function MyApp:isObjectExists(id)
    return self.objects_[id] ~= nil
end

return MyApp
