local CheckUpdateScene = class("CheckUpdateScene", function()
  return display.newScene("CheckUpdateScene")
end)


function CheckUpdateScene:splashOver()
  if (CCUserDefault:sharedUserDefault():getStringForKey("music")=="open"
       or  CCUserDefault:sharedUserDefault():getStringForKey("music")=="") then
        audio.playBackgroundMusic("res/music/battle4.mp3")
      end

      self.background = display.newSprite("res/ui/account/account_bg.jpg", display.cx, display.cy):addTo(self,-10)
      self.logo = display.newSprite("res/ui/account/account_logo.png", display.cx, display.top-95):addTo(self,10)
      self.logo:setOpacity(0)
      self.logo:runAction(CCFadeIn:create(2))
      self.gameTip = display.newSprite("res/ui/account/account_logoyun.png", display.cx, display.bottom+40):addTo(self,10)

      local niuFrames = display.newFrames("niu_%d.png",1,8)
      local niuAnimation = display.newAnimation(niuFrames,1/8)
      self.niu = display.newSprite(niuFrames[1],display.right-230,display.cy-25):addTo(self)
      self.niu:playAnimationForever(niuAnimation)
      self.niu:setScale(0.9)


      local produceBullet = function(posX,posY,moveTime,dx,dy,rotation,zorder,scale)
        local frames = display.newFrames("bullet_41005_%02d.png", 1, 5)
        local bulletAnimation = display.newAnimation(frames,0.4/5)
        local bullet = display.newSprite(frames[1],posX,posY):addTo(self,zorder)
        bullet:setRotation(rotation)
        bullet:setScale(scale)

        transition.execute(bullet, CCMoveBy:create(moveTime, ccp(dx,dy)),{
            onComplete = function()
              bullet:removeSelf()
            end,
        })
      end

      local onSchedule = function()
          local num = math.random(10)
          if num<3 then
            produceBullet(display.cx-100,display.top,0.6,-200,-100,150,-4,0.5)
          elseif num<6 then
            produceBullet(display.cx+200,display.cy+100,1,-400,-200,150,-2,0.7)
          else
            produceBullet(display.cx,display.cy+50,0.8,-300,-150,150,-1,0.8)
          end
      end

      onSchedule()
      self:schedule(onSchedule,2)

    ----初始化下载提示信息-----------------------------------------------------------------------------------------------
      self.tipText = ui.newTTFLabelWithOutline({
          text = "更新检查中...",
          --font = "fzzhunyuan",
          size = 16,
          color = ccc3(0, 0, 0),
          outlineColor = ccc3(255, 255, 255),
          x = display.cx-50,
          y = display.cy-160
      }):addTo(self)

      self.downloadProgressText = ui.newTTFLabel({
          text = "",
          --font = "fzzhunyuan",
          size = 14,
          color = ccc3(255, 255, 255),
          x = display.cx+80,
          y = display.cy-160
      }):addTo(self)

      self.speedText = ui.newTTFLabel({
          text = "",
          --font = "fzzhunyuan",
          size = 14,
          color = ccc3(255, 255, 255),
          x = display.cx+135,
          y = display.cy-160
      }):addTo(self)
      self.downloadText = ui.newTTFLabel({
          text = "",
          --font = "fzzhunyuan",
          size = 14,
          color = ccc3(255,0,0),
          x = display.cx+205,
          y = display.cy-160
      }):addTo(self)
      self.totalText = ui.newTTFLabel({
          text = "",
          --font = "fzzhunyuan",
          size = 14,
          color = ccc3(255,0,0),
          x = display.cx+260,
          y = display.cy-160
      }):addTo(self)
    ----初始化下载提示信息---------------------------------------------------------------------------------------------------
    if io.exists(CCFileUtils:sharedFileUtils():getWritablePath().."config.lua") then
      if io.exists(CCFileUtils:sharedFileUtils():getWritablePath().."game_precompiled.zip") then
        package.loaded["config"] = nil
        require("config")
      end
    end
    self:addVersion()
    self:checkUpdate()
    --self:goToLoginScene()
end



function CheckUpdateScene:ctor()
  
  addRes(self.name,"res/ani/pve/skill/skill_41005.plist","res/ani/pve/skill/skill_41005.pvr.ccz")
  addRes(self.name,"res/niu.plist","res/niu.pvr.ccz")

  local splashSprite = display.newSprite("res/splash.jpg", display.cx, display.cy):addTo(self)
  splashSprite:setOpacity(0)


  local action = transition.sequence({
    CCFadeIn:create(1.5),
    CCFadeOut:create(1.5),
    CCCallFunc:create(function()
      splashSprite:removeSelf()
      self:splashOver()
    end),})
  splashSprite:runAction(action)

  if (device.platform == 'android') then
      local javaClassName = "org.cocos2dx.lib.Function"
      local javaMethodName = "getApkVersion"
      local javaParams = {}
      local javaMethodSig = "()I"
      local ok, realApkVersionCode = luaj.callStaticMethod(javaClassName,javaMethodName,javaParams,javaMethodSig)
      self.realApkVersionCode = tonumber(realApkVersionCode)
      luaj.callStaticMethod("org/cocos2dx/lib/Function", "setLoginFunc", {relogin_func},"(I)V")
  end
    
end

function CheckUpdateScene:checkUpdate()

  function onRequestFinished(event)
    local ok = (event.name == "completed")
    local request = event.request
    if not ok then
        --print("初始化获取版本号失败")
        self:makeReConnectWindow()
        return
    end
    local code = request:getResponseStatusCode()
    if code ~= 200 then
        --请求结束，但没有返回 200 响应代码
        --print("请求超时了,或者没有网络",code)
        self:makeReConnectWindow()
        return
    end
    -- 请求成功，显示服务端返回的内容
    local response = totable(json.decode(request:getResponseString()))
    local retCode = response["ret"] 
    local updateHistoryList = response["updateHistoryList"]
    local apkVersion = response["apkVersion"]
    local apkAddress = response["apkAddress"]

    if apkAddress==nil or apkAddress=="" then
      apkAddress = "http://www.baidu.com"
    end

    if retCode~=0 then--返回retCode不为0时，服务器配置出错,跳过更新
      self.tipText:setString("版本检测错误")
      self:goToLoginScene()
      return
    end

    -----------------------------------------------获取当前服务器APK的版本号码---------------------------
    if (device.platform == 'android') then
      if self.realApkVersionCode<tonumber(apkVersion) then
      --if true then
        self.tipText:setString("版本太旧,请去游戏中心下载最新版本")

        local javaClassName = "org.cocos2dx.lib.Function"
        local javaMethodName = "newApk"
        local javaParams = {apkAddress}
        local javaMethodSig = "(Ljava/lang/String;)V"
        luaj.callStaticMethod(javaClassName,javaMethodName,javaParams,javaMethodSig)

        return
      end
    end

    -----------------------------------------------获取当前服务器APK的版本号码----------------------------------------------------------
    local forceUpdate = (updateHistoryList[#updateHistoryList]~=nil) and (updateHistoryList[#updateHistoryList]["forceUpdate"]=="TRUE") or false
    print("是否强制更新",forceUpdate)
    local updateinfoFilePath = CCFileUtils:sharedFileUtils():getWritablePath().."updateinfo"
    local fileContent = ""
    if not io.exists(updateinfoFilePath) then
      --print("更新文件不存在")
      print("fileContent not exist",fileContent)
    else  
      --print("更新文件存在")
      file = io.open(updateinfoFilePath, "r")
      fileContent = file:read("*a")
      file:close()
      print("fileContent exist",fileContent)
    end
    --print("当前版本是",currentVersion,response)
    --require("app.common.DebugUtil").print_table(response)
    local updateInfo = ""
    self.allVersion = {}
    local isBack = false
    if isBack then
    --if tostring(isBack)=="true" then
      --print("版本回退,只更新脚本")
      local list = updateHistoryList[#updateHistoryList]
      local versionCode = list["versionCode"]
      self.allVersion[#self.allVersion+1] = versionCode
      local res = list["res"]
      local script = list["script"]
      updateInfo = updateInfo..versionCode.."##".."notDownload".."##"..RESOURCE_SCRIPT_ADDRESS_PREFIX..script.."\n"
    else
      --print("版本更新,检测要更新的脚本和资源包",#updateHistoryList)
      for i=1,#updateHistoryList do
        local list = updateHistoryList[i]
        --updateInfo = updateInfo..list["versionCode"].."##"..RESOURCE_SCRIPT_ADDRESS_PREFIX..list["res"].."##"..RESOURCE_SCRIPT_ADDRESS_PREFIX..list["script"].."\n"
        local versionCode = list["versionCode"]
        self.allVersion[#self.allVersion+1] = versionCode
        local res = list["res"]
        local script = list["script"]
        local apkVersionCode = list["apkVersionCode"]
        
        if (device.platform == 'android') then
        --if true then
          local e,f = string.find(fileContent,versionCode..":".."[truefalse]+")
          if e~=nil and f~=nil then
            local currentList = string.sub(fileContent, e, f)
            local k,m = string.find(currentList,"[truefalse]+")
            if k~=nil and m~=nil then
              local status = string.sub(currentList,k,m)
              if status=="false" then
                local resAddress = (res~=nil and tostring(res)~="") and (res) or "notDownload"
                local scriptAddress = (script~=nil and tostring(script)~="" and i==#updateHistoryList) and (script) or "notDownload"
                updateInfo = updateInfo..versionCode.."##"..resAddress.."##"..scriptAddress.."\n"
              else
                --print("你已经更新过了")
              end
            end
          else
            local resAddress = (res~=nil and tostring(res)~="") and (res) or "notDownload"
            local scriptAddress = (script~=nil and tostring(script)~="" and i==#updateHistoryList) and (script) or "notDownload"
            updateInfo = updateInfo..versionCode.."##"..resAddress.."##"..scriptAddress.."\n"
          end
        elseif device.platform=='windows' then
          local e,f = string.find(fileContent,versionCode..":".."[truefalse]+")
          if e~=nil and f~=nil then
            local currentList = string.sub(fileContent, e, f)
            local k,m = string.find(currentList,"[truefalse]+")
            if k~=nil and m~=nil then
              local status = string.sub(currentList,k,m)
              if status=="false" then
                local resAddress = (res~=nil and tostring(res)~="") and (res) or "notDownload"
                local scriptAddress = (script~=nil and tostring(script)~="" and i==#updateHistoryList) and (script) or "notDownload"
                updateInfo = updateInfo..versionCode.."##"..resAddress.."##"..scriptAddress.."\n"
              else
                --print("你已经更新过了")
              end
            end
          else
            local resAddress = (res~=nil and tostring(res)~="") and (res) or "notDownload"
            local scriptAddress = (script~=nil and tostring(script)~="" and i==#updateHistoryList) and (script) or "notDownload"
            updateInfo = updateInfo..versionCode.."##"..resAddress.."##"..scriptAddress.."\n"
          end
        end
      end
    end

    --print("更新信息",updateInfo)
    local ifUpdate = false
    local e,f = string.find(updateInfo,"zip")
    if e~=nil and f~=nil then
      ifUpdate = true
      print("有资源需要更新",updateInfo)
    end

    if not ifUpdate then
      print("最新版本,无需更新",updateInfo)
      ui.newTTFLabelWithOutline({
          text = "xxxxxxxxxx",
          --font = "fzzhunyuan",
          size = 16,
          color = ccc3(0, 0, 0),
          outlineColor = ccc3(255, 255, 255),
          x = display.cx/4,
          y = display.cy
      }):addTo(self)
      self:goToLoginScene()
    else
      --print("马上更新了")
      if (device.platform == 'android') then
          local javaClassName = "org.cocos2dx.lib.Function"
          local javaMethodName = "getNetworkType"
          local javaParams = {}
          local javaMethodSig = "()I"
          local ok, ret = luaj.callStaticMethod(javaClassName,javaMethodName,javaParams,javaMethodSig)
          if tonumber(ret)==0 then
            self:download(updateInfo)
          elseif tonumber(ret)==-1 then
            self:makeReConnectWindow()
          else
            self:makeDownloadConfirmWindow(updateInfo,forceUpdate)
          end
      elseif (device.platform == 'mac') then
        print("mac平台不提供多个资源包更新")
        --self:makeDownloadConfirmWindow(updateInfo,forceUpdate)
        --print("非android平台")
        --display.replaceScene(require("app.scenes.UpdateScene").new(updateZipAddress))
      elseif (device.platform == 'windows') then
        --print("windows平台不提供多个资源包更新")
        self:makeDownloadConfirmWindow(updateInfo,forceUpdate)
        --print("非android平台")
        --display.replaceScene(require("app.scenes.UpdateScene").new(updateZipAddress))
      end
    end
  end

  local packageName = nil
  local cId = nil
  if (device.platform == 'android') then
    local javaClassName = "org.cocos2dx.lib.Function"
    local javaMethodName = "getPackageName"
    local javaParams = {}
    local javaMethodSig = "()Ljava/lang/String;"
    local ok,cName = luaj.callStaticMethod(javaClassName,javaMethodName,javaParams,javaMethodSig)
    if ok then
      packageName = cName
    end
  else
    packageName = "com.mobi2us.td.qihu"
  end

  if (device.platform == 'android') then
    local javaClassName = "org.cocos2dx.lib.Function"
    local javaMethodName = "getChannel"
    local javaParams = {}
    local javaMethodSig = "()Ljava/lang/String;"
    local ok,id = luaj.callStaticMethod(javaClassName,javaMethodName,javaParams,javaMethodSig)
    if ok then
      cId = id
    end
  else
    cId = "000023"
  end

  local releaseMode = 1
  if (device.platform == 'android') then
      local javaClassName = "org.cocos2dx.lib.Function"
      local javaMethodName = "getRelease"
      local javaParams = {}
      local javaMethodSig = "()I"
      local ok, release = luaj.callStaticMethod(javaClassName,javaMethodName,javaParams,javaMethodSig)
      releaseMode = release
    end
  
  --cId = "000066"
  --packageName = "com.mobi2us.td.xiaomi"
  local versionCheckUrl = "http://118.192.87.94/gamesrv/MobiFlist.html?channel_id="..cId.."&pkg_name="..packageName.."&release="..releaseMode.."&version="..APP_VERSION
  local request = network.createHTTPRequest(onRequestFinished,versionCheckUrl,"GET")
  --[[
  self.ppxy = ui.newTTFLabelWithOutline({
          text = versionCheckUrl,
          --font = "fzzhunyuan",
          size = 15,
          color = ccc3(255, 0, 0),
          outlineColor = ccc3(255, 255, 255),
          x = 0,
          y = display.cy
      }):addTo(self)]]
  print("版本比对的地址是",versionCheckUrl,APP_VERSION)
  request:start()

end

function CheckUpdateScene:makeReConnectWindow()
  local onConfirm = function()
    print("从新连接")
    self:checkUpdate()
  end

  local onCancel = function()
    print("退出程序")
    if  (device.platform == 'android') then
            local ok, ret = luaj.callStaticMethod("org/cocos2dx/lib/Function", "ExitApp", "()V")
            if not ok then
                print("luaj error: ", ret)
                app.exit()
            end
        elseif (device.platform == 'ios') then
            app.exit()
        else
            app.exit()
        end
    return 
  end

  self.ReconnectWindow = display.newSprite("res/ui/public/public_prompt.png",display.cx,display.cy)
  local YPos = 35

  local title = ui.newTTFLabelWithOutline({
      --text = "你的网络状况不太好,点击按钮重连",
      text = "重连",
      x = 190,
      y = 170,
      size = 18,
      color = display.COLOR_BLACK,
        outlineColor = display.COLOR_WHITE,
      align = ui.TEXT_ALIGN_CENTER
  }):addTo(self.ReconnectWindow)

  local content = ui.newTTFLabel({
      text = "你的网络状况不太好,点击按钮重连",
      x = 200,
      y = 120,
      size = 18,
       color = display.COLOR_BLACK,
      align = ui.TEXT_ALIGN_CENTER,
       dimensions = CCSize(16 * 19, 16 * 3)
  }):addTo(self.ReconnectWindow)

  local function onItem1Click()
      onConfirm()
      self.ReconnectWindow:removeFromParentAndCleanup(true)
  end

  local function onItem2Click()
      onCancel()
      self.ReconnectWindow:removeFromParentAndCleanup(true)
  end

  local item1 = ui.newImageMenuItem({
      image = "res/ui/public/public_reconnection_btn_normal.png",
      imageSelected = "res/ui/public/public_reconnection_btn_pressed.png",
      listener = onItem1Click,
      x = 105,
      y = YPos
  })
  
  local item2 = ui.newImageMenuItem({
     image = "res/ui/public/public_to_withdraw_btn_normal.png",
      imageSelected = "res/ui/public/public_to_withdraw_btn_pressed.png",
      listener = onItem2Click,
      x = 300,
      y = YPos
  })
  local menu = ui.newMenu({item1,item2})
  self.ReconnectWindow:addChild(menu)
  self:addChild(self.ReconnectWindow,GUIDE_PAGE_Z_ORDER)
end

function CheckUpdateScene:download(updateInfo)
  self:initProgressBar()
  self.tipText:setString("更新资源中....")
  local function downloadSuccessCallback(ret)
    --if ret~="completed" then
    if true then
      --print("下载完了",ret,ret[1],ret[2],ret[3],ret[4])
      for i=1,#self.allVersion do
        local path = CCFileUtils:sharedFileUtils():getWritablePath()
        local resZip = CCFileUtils:sharedFileUtils():getWritablePath().."res_"..self.allVersion[i]..".zip"
        local scriptZip = CCFileUtils:sharedFileUtils():getWritablePath().."script_"..self.allVersion[i]..".zip"
        print("路径",resZip,scriptZip)
        if io.exists(resZip) then
          if ResourceFileUtil:sharedInstance():uncompress(path,resZip) then
            print("解压成功",resZip)
          else
            print("解压失败",resZip)
          end
          DownloadUtil:deleteFile(resZip)
        else
          print("压缩包不存在",resZip)
        end
        if io.exists(scriptZip) then
          if ResourceFileUtil:sharedInstance():uncompress(path,scriptZip) then
            print("解压成功",scriptZip)
          else
            print("解压失败",scriptZip)
          end
          DownloadUtil:deleteFile(scriptZip)
        else
          print("压缩包不存在",scriptZip)
        end
      end
      self:goToLoginScene()
    end
  end
  local javaClassName = "org.cocos2dx.lib.Function"
  local javaMethodName = "startDownload"
  local javaParams = {
    updateInfo,
    downloadSuccessCallback
  }
  local javaMethodSig = "(Ljava/lang/String;I)V"
  luaj.callStaticMethod(javaClassName,javaMethodName,javaParams,javaMethodSig)
  self:schedule(handler(self,self.updateDownloadInfo),1/60)
end

function CheckUpdateScene:updateDownloadInfo()
  if not io.exists(CCFileUtils:sharedFileUtils():getWritablePath().."downloadInfo.txt") then return end
  file = io.open(CCFileUtils:sharedFileUtils():getWritablePath().."downloadInfo.txt", "r")
  local line = file:read()
  file:close()
  --print("每半秒中获取下载信息",line)
  if line==nil then 
    return
  end
  local downloadingInfos = self:split(line,",",5)
  local downloadNow = tonumber(downloadingInfos[1])
  local downloadTotal = tonumber(downloadingInfos[2])
  local percentage = tonumber(downloadingInfos[3])
  local bytesPerSecond = tonumber(downloadingInfos[4]) * 10
  local tipStr = percentage.."%"

  --print(111111111111)
  if self.totalSizeStr==nil and downloadTotal>0 then
    if downloadTotal > 1024*1024 then
      local totalM,totalK = math.modf(downloadTotal/(1024*1024))
      local bb = totalM + totalK
      self.totalSizeStr = string.format("%6.2f",bb).."M"
    elseif downloadTotal > 1024 then
      local totalK,totalB = math.modf(downloadTotal/(1024))
      local bb = totalK + totalB
      self.totalSizeStr = string.format("%6.2f",bb).."K"
    else
      self.totalSizeStr = downloadTotal.."B"
    end
  end
  --print(222222222222)

  if downloadNow > 1024*1024 then
    local totalM,totalK = math.modf(downloadNow/(1024*1024))
    local bb = totalM + totalK
    self.downloadSizeStr = string.format("%6.2f",bb).."M"
  elseif downloadNow > 1024 then
    local totalK,totalB = math.modf(downloadNow/(1024))
    local bb = totalK + totalB
    self.downloadSizeStr = string.format("%6.2f",bb).."K"
  else
    self.downloadSizeStr = downloadNow.."B"
  end
  --print(33333333333)
  if bytesPerSecond > 1024*1024 then
    local totalM,totalK = math.modf(bytesPerSecond/(1024*1024))
    local bb = totalM + totalK
    self.speedStr = string.format("%6.2f",bb).."M/秒"
  elseif bytesPerSecond > 1024 then
    local totalK,totalB = math.modf(bytesPerSecond/(1024))
    local bb = totalK + totalB
    self.speedStr = string.format("%6.0f",bb).."K/秒"
  else
    self.speedStr = bytesPerSecond.."B/秒"
  end
  self.downloadProgressText:setString(tipStr)
  self.totalText:setString(self.totalSizeStr)
  self.downloadText:setString(self.downloadSizeStr.."/")
  self.speedText:setString(self.speedStr)
  self:setPercentage(percentage)
  --print(4444444444444)

end

function CheckUpdateScene:makeDownloadConfirmWindow(updateInfo,forceUpdate)

  print("makeDownloadConfirmWindow",forceUpdate)

  local function confirmCallback(sizeStr)
    --local sizeStr = "99999"
    local downloadResourceSize = tonumber(sizeStr)
    if downloadResourceSize > 1024*1024 then
      local totalM,totalK = math.modf(downloadResourceSize/(1024*1024))
      local bb = totalM + totalK
      totalSizeStr = string.format("%6.2f",bb).."M"
    elseif downloadResourceSize > 1024 then
      local totalK,totalB = math.modf(downloadResourceSize/(1024))
      local bb = totalK + totalB
      totalSizeStr = string.format("%6.2f",bb).."K"
    else
      totalSizeStr = downloadResourceSize.."B"
    end

    --print("文件的大小是%d__%s",sizeStr,downloadResourceSize,totalSizeStr)


    self.confirmDownloadWindow = display.newSprite("res/ui/public/public_prompt.png",display.cx,display.cy)
    local YPos = 35
    
    local title = ui.newTTFLabelWithOutline({
        --text = "你的网络状况不太好,点击按钮重连",
        text = "更新资源",
        x = 190,
        y = 170,
        size = 18,
        color = display.COLOR_BLACK,
        outlineColor = display.COLOR_WHITE,
        align = ui.TEXT_ALIGN_CENTER
    }):addTo(self.confirmDownloadWindow)

    local content = ui.newTTFLabel({
        text = "目前使用手机2G/3G网络确定更新吗?",
        x = 200,
        y = 120,
        size = 18,
        color = display.COLOR_BLACK,
        align = ui.TEXT_ALIGN_CENTER,
        dimensions = CCSize(16 * 19, 16 * 3)
    }):addTo(self.confirmDownloadWindow)


    local downloadSizeTip = ui.newTTFLabel({
        text = totalSizeStr,
        x = 200,
        y = 80,
        size = 20,
        color = display.COLOR_RED,
        align = ui.TEXT_ALIGN_CENTER,
        dimensions = CCSize(16 * 19, 16 * 3)
    }):addTo(self.confirmDownloadWindow)

    local item1 = ui.newImageMenuItem({
        image = "res/ui/public/public_definite_normal.png",
        imageSelected = "res/ui/public/public_definite_pressed.png",
        listener = function()
          self.confirmDownloadWindow:removeFromParentAndCleanup(true)
          self:download(updateInfo)
        end,
        x = 105,
        y = YPos
    })
    
    local item2 = ui.newImageMenuItem({
       image = "res/ui/public/public_cancel_normal.png",
        imageSelected = "res/ui/public/public_cancel_pressed.png",
        listener = function()
          self.confirmDownloadWindow:removeFromParentAndCleanup(true)
          print("手机网络可以不用更新直接进入游戏")
          if  (device.platform == 'android') then
              if forceUpdate then
                local ok, ret = luaj.callStaticMethod("org/cocos2dx/lib/Function", "ExitApp", "()V")
                if not ok then
                    print("luaj error: ", ret)
                    app.exit()
                end
              else
                self:goToLoginScene()
              end
          elseif (device.platform == 'ios') then
              app.exit()
          else
              app.exit()
          end
          self:goToLoginScene()
        end,
        x = 300,
        y = YPos
    })
    local menu = ui.newMenu({item1,item2})
    self.confirmDownloadWindow:addChild(menu)
    self:addChild(self.confirmDownloadWindow,GUIDE_PAGE_Z_ORDER)

  end

  if (device.platform == 'android') then
    local javaClassName = "org.cocos2dx.lib.Function"
    local javaMethodName = "getDownloadFileLength"
    local javaParams = {
      updateInfo,
      confirmCallback
    }
    local javaMethodSig = "(Ljava/lang/String;I)V"
    luaj.callStaticMethod(javaClassName,javaMethodName,javaParams,javaMethodSig)
  elseif (device.platform == 'ios') then

  else

  end

end

function CheckUpdateScene:goToLoginScene()

local loadFromInstall = true

if io.exists(CCFileUtils:sharedFileUtils():getWritablePath().."config.lua") then
  if io.exists(CCFileUtils:sharedFileUtils():getWritablePath().."game_precompiled.zip") then
    package.loaded["config"] = nil
    require("config")
    loadFromInstall = false
  end
end

  if loadFromInstall then
    CCLuaLoadChunksFromZIP("res/game_precompiled.zip")
    print("load path", "res/game_precompiled.zip")
  else
    CCLuaLoadChunksFromZIP(CCFileUtils:sharedFileUtils():getWritablePath().."game_precompiled.zip")
    print("load path", CCFileUtils:sharedFileUtils():getWritablePath().."game_precompiled.zip")
  end

  CCFileUtils:sharedFileUtils():addSearchPath(CCFileUtils:sharedFileUtils():getWritablePath().."res/")
  CCFileUtils:sharedFileUtils():addSearchPath("res/")
  require("config")
  require("app.AppDef")
  CommUtil.InitAppData()
  --初始化测试用数据
  DebugUtil.initAppTestData()
  --网络轮循
  gSock.initSockScheduler()
  
  local function func_mobi() 
    print("跳转至mobi LoginScene")
    display.replaceScene(require("app.scenes.LoginScene").new())
  end
  local function func_xiaomi() 
    print("跳转至小米LoginScene")
    display.replaceScene(require("app.scenes.MILoginScene").new())    
  end
  local function func_anySdk()
    print("跳转至anySdk LoginScene")
    display.replaceScene(require("app.scenes.AnySdkLoginScene").new()) 
  end
  CommUtil.accessPlatform(func_mobi, func_anySdk, func_anySdk)
end

function CheckUpdateScene:addVersion()
  self.fileList = nil
  self.path = device.writablePath.."upd/"
    self.curListFile =  self.path.."mobi_flist"    
    if io.exists(self.curListFile) then
        self.fileList = dofile(self.curListFile)
    end
    if self.fileList==nil then
        self.fileList = {
            ver = "1.0.0",
            stage = {},
            remove = {},
        }
    end
    -----
    AddVersionFunc(self)

   
end

--退出处理
function CheckUpdateScene:onExit()
  delRes(self.name)
end

function CheckUpdateScene:onEnter()
  self.showExit = false
  if device.platform == "android" then
        self:performWithDelay(function()
            local layer = display.newLayer()
            layer:addKeypadEventListener(function(event)
                if event == "back" then
                  if (not self.showExit) then
                    self.showExit = true
                      self.exitWindow = self:makeExitWindow()
                    else
                      self.showExit = false
                      self.exitWindow:removeFromParentAndCleanup()  
                    end
                end
            end)
            self:addChild(layer, GUIDE_PAGE_Z_ORDER)
            layer:setKeypadEnabled(true)
        end, 0.5)
    end
end

function CheckUpdateScene:makeExitWindow()
  local onConfirm = function()
        if  (device.platform == 'android') then
            local ok, ret = luaj.callStaticMethod("org/cocos2dx/lib/Function", "ExitApp", "()V")
            if not ok then
                print("luaj error: ", ret)
                app.exit()
            end
        elseif (device.platform == 'ios') then
            app.exit()
        else
            app.exit()
        end
    end

  local onCancel = function() self.window:removeFromParentAndCleanup(true) return end

  self.window = display.newSprite("res/ui/public/public_quit_bg.png",display.cx,display.cy):addTo(self,GUIDE_PAGE_Z_ORDER+1)
  local YPos = 35

  local item1 = ui.newImageMenuItem({
      image = "res/ui/public/public_quit_yes_btn.png",
      imageSelected = "res/ui/public/public_quit_yes_btn_pressed.png",
      listener = onConfirm,
      x = 105,
      y = YPos
  })
  
  local item2 = ui.newImageMenuItem({
     image = "res/ui/public/public_quit_no_btn.png",
      imageSelected = "res/ui/public/public_quit_no_btn_pressed.png",
      listener = onCancel,
      x = 300,
      y = YPos
  })
  local menu = ui.newMenu({item1,item2})
  self.window:addChild(menu)
end

function CheckUpdateScene:split(str,delim,maxNb)   
     -- Eliminate bad cases...   
     if string.find(str, delim) == nil then  
         return { str }  
     end  
     if maxNb == nil or maxNb < 1 then  
         maxNb = 0    -- No limit   
     end  
     local result = {}  
     local pat = "(.-)" .. delim .. "()"   
     local nb = 0  
     local lastPos   
     for part, pos in string.gfind(str, pat) do  
         nb = nb + 1  
         result[nb] = part   
         lastPos = pos   
         if nb == maxNb then break end  
     end  
     -- Handle the last field   
     if nb ~= maxNb then  
         result[nb + 1] = string.sub(str, lastPos)   
     end  
     return result   
 end

 function CheckUpdateScene:initProgressBar()
  local len = 44
  local con_len = 31
  local bg_len = 296
  local prgs_len = 260

  local progressNode = display.newNode():addTo(self,100)

  local bg_scaleX = (600-16) / bg_len
  local bg = display.newSprite("res/ui/public/public_progressbar_grounding.png"):pos(10,8):addTo(progressNode,1)
  bg:setScaleX(bg_scaleX)
  bg:setAnchorPoint(CCPoint(0,0))

  self.prgs = display.newSprite("res/ui/public/public_progressbar_graduation.png"):pos(9,8):addTo(progressNode,2)
  self.prgs:setAnchorPoint(CCPoint(0,0))
  self.prgs:setScaleX(0)

  self.prgs_effect = display.newSprite("res/ui/public/public_progressbar_effect.png"):pos(-10,-3):addTo(progressNode,4)
  self.prgs_effect:setAnchorPoint(CCPoint(0,0))

  local frame_l = display.newSprite("res/ui/public/public_progressbar_frame.png"):pos(0,0):addTo(progressNode,3)
  frame_l:setAnchorPoint(CCPoint(0,0))
  local frame_r = display.newSprite("res/ui/public/public_progressbar_frame.png"):pos(600-len,0):addTo(progressNode,3)
  frame_r:setAnchorPoint(CCPoint(0,0))
  frame_r:setFlipX(true)
  local m_scaleX = (600 - 2*len) / con_len
  local frame_m = display.newSprite("res/ui/public/public_progressbar_connect.png"):pos(len,5):addTo(progressNode,3)
  frame_m:setAnchorPoint(CCPoint(0,0))
  frame_m:setScaleX(m_scaleX)

  self.prgs_scaleX = (600-18) / prgs_len
  self.percentage = 0
  progressNode:setPosition(ccp(display.cx - 600/2,display.cy - 200))
end

function CheckUpdateScene:setPercentage(percentage)
  if percentage==nil then return end
  local prgs_scale = self.prgs_scaleX * percentage / 100
  --计算进度点x坐标
  local effect_start_x = -10
  local effect_end_x = effect_start_x+600-25
  local effect_len = effect_end_x - effect_start_x
  local effect_pos_x = effect_len * percentage / 100 + effect_start_x
  self.prgs:setScaleX(prgs_scale)
  self.prgs_effect:setPositionX(effect_pos_x)
end


return CheckUpdateScene
